NEMO_billing/prepayments/urls.py
from NEMO.urls import router, sort_urls
from django.urls import path

from NEMO_billing.prepayments import api
from NEMO_billing.prepayments.views import prepayments

# Rest API URLs
router.register(r"billing/funds", api.FundViewSet)
router.register(r"billing/fund_types", api.FundTypeViewSet)
router.register(r"billing/project_prepayments", api.ProjectPrepaymentDetailViewSet)
router.registry.sort(key=sort_urls)

urlpatterns = [
    path("usage_project_prepayments/", prepayments.usage_project_prepayments, name="usage_project_prepayments"),
    path("prepaid_project_status/", prepayments.prepaid_project_status, name="prepaid_project_status"),
]

NEMO_billing/urls.py
from NEMO.urls import router, sort_urls
from django.urls import path, re_path

from NEMO_billing import api, views

# Rest API URLs
router.register(r"billing/custom_charges", api.CustomChargeViewSet)
router.register(r"billing/departments", api.DepartmentViewSet)
router.register(r"billing/institution_types", api.InstitutionTypeViewSet)
router.register(r"billing/institutions", api.InstitutionViewSet)
router.registry.sort(key=sort_urls)

urlpatterns = [
    path("custom_charges/", views.custom_charges, name="custom_charges"),
    path("custom_charge/", views.create_or_modify_custom_charge, name="create_custom_charge"),
    path("custom_charge/<int:custom_charge_id>", views.create_or_modify_custom_charge, name="edit_custom_charge"),
    path(
        "get_projects_for_custom_charges/",
        views.get_projects_for_custom_charges,
        name="get_projects_for_custom_charges",
    ),
    # Overriding NEMO create staff charge URLs to add core facility selection
    path("staff_charges/", views.custom_staff_charges, name="staff_charges"),
    path("begin_staff_charge/", views.custom_begin_staff_charge, name="begin_staff_charge"),
    # Overriding NEMO enable tool URL to set the core facility on staff charge based on the tool's core facility
    path(
        "enable_tool/<int:tool_id>/user/<int:user_id>/project/<int:project_id>/staff_charge/<str:staff_charge>/",
        views.custom_enable_tool,
        name="enable_tool",
    ),
    # Override broadcast email to add new search for PIs by institution types
    path("email_broadcast/", views.email_broadcast, name="email_broadcast"),
    re_path(
        r"^email_broadcast/(?P<audience>tool|area|account|project|project-pis|user|tool-reservation|group|pi_institution_types)/$",
        views.email_broadcast,
        name="email_broadcast",
    ),
]

NEMO_billing/cap_discount/models.py
from __future__ import annotations

from datetime import MAXYEAR, MINYEAR, date, datetime
from decimal import Decimal
from typing import Dict, List, Optional, Tuple

from NEMO.constants import CHAR_FIELD_SMALL_LENGTH
from NEMO.models import Account, BaseModel, User
from NEMO.typing import QuerySetType
from NEMO.utilities import RecurrenceFrequency, format_datetime, get_recurring_rule
from dateutil.rrule import rrule
from django.core.exceptions import ValidationError
from django.core.validators import MaxValueValidator, MinValueValidator, validate_comma_separated_integer_list
from django.db import IntegrityError, models, transaction
from django.db.models import Q, UniqueConstraint
from django.db.models.signals import m2m_changed
from django.dispatch import receiver

from NEMO_billing.invoices.models import BillableItemType
from NEMO_billing.models import CoreFacility
from NEMO_billing.rates.models import RateCategory
from NEMO_billing.utilities import Months


class CAPDiscountConfiguration(BaseModel):
    rate_category = models.ForeignKey(
        RateCategory, help_text="The rate category this CAP applies to", on_delete=models.CASCADE
    )
    core_facilities = models.ManyToManyField(
        CoreFacility,
        blank=True,
        help_text="The core facility(ies) this CAP applies to. If multiple are selected, the CAP is shared between facilities",
    )
    charge_types = models.CharField(
        validators=[validate_comma_separated_integer_list],
        max_length=CHAR_FIELD_SMALL_LENGTH,
        help_text="List of charge type this CAP applies to",
    )
    start_on_first_charge = models.BooleanField(
        default=True, help_text="Automatically set CAP start date to the month of the first eligible charge"
    )
    split_by_user = models.BooleanField(
        default=True,
        help_text="Check this box to have a separate CAP amount per each user/account. If unchecked, the CAP will be per account only (all user charges count towards the same CAP)",
    )
    # Recurring schedule
    start_month = models.PositiveIntegerField(
        null=True, blank=True, choices=Months.choices, help_text="Start month of the CAP discount"
    )
    start_year = models.PositiveIntegerField(
        null=True,
        blank=True,
        help_text="Start year of the CAP discount",
        validators=[MinValueValidator(1900), MaxValueValidator(MAXYEAR)],
    )
    reset_interval = models.PositiveIntegerField(
        default=1,
        validators=[MinValueValidator(1)],
        help_text="Recurring interval, i.e. every 5 days.",
    )
    reset_frequency = models.PositiveIntegerField(
        choices=[
            (RecurrenceFrequency.MONTHLY.index, RecurrenceFrequency.MONTHLY.display_value),
            (RecurrenceFrequency.YEARLY.index, RecurrenceFrequency.YEARLY.display_value),
        ],
        help_text="The CAP reset frequency.",
    )

    @property
    def start(self) -> date:
        if self.start_year and self.start_month:
            return date(self.start_year, self.start_month, 1)

    @start.setter
    def start(self, value: date):
        if value:
            self.start_month, self.start_year = value.month, value.year
        else:
            self.start_month, self.start_year = None, None

    @property
    def billable_charge_types(self) -> List[BillableItemType]:
        return [BillableItemType(int(value)) for value in self.charge_types.split(",") if value]

    @property
    def core_facility_names(self) -> Tuple[str]:
        return tuple(cf.name for cf in self.core_facilities.all())

    @property
    def get_reset_frequency_enum(self):
        return RecurrenceFrequency(self.reset_frequency)

    def clean(self):
        errors = {}
        # We need to check ids otherwise it will throw a RelatedObjectDoesNotExist if they are not set even if required
        if self.start_month and not self.start_year or self.start_year and not self.start_month:
            errors["start_year"] = "Both year/month are required together"
            errors["start_month"] = "Both year/month are required together"
        if not self.start and not self.start_on_first_charge:
            errors["start_year"] = "Year is required when `Start on first charge` is unchecked."
            errors["start_month"] = "Month is required when `Start on first charge` is unchecked."
        if self.start and self.start_on_first_charge:
            errors["start_on_first_charge"] = "You entered a start date, remove it or unchecked this box."
        if errors:
            raise ValidationError(errors)

    def get_recurrence_interval_display(self) -> str:
        if not self.reset_frequency:
            return ""
        interval = f"{self.reset_interval} " if self.reset_interval != 1 else ""
        f_enum = self.get_reset_frequency_enum
        frequency = f"{f_enum.display_text}s" if self.reset_interval != 1 else f_enum.display_text
        return f"Every {interval}{frequency}"

    @transaction.atomic
    def get_or_create_cap_discount(self, account: Account, username: Optional[str], start: date):
        try:
            # Cap discount exists, return it
            return CAPDiscount.objects.get(configuration=self, account=account, user__username=username)
        except CAPDiscount.DoesNotExist:
            # Cap discount doesn't exist, create it
            user = User.objects.get(username=username) if username else None
            new_cap_discount = CAPDiscount(configuration=self, account=account, user=user)
            cap_discount_tiers = self.initialize_cap_discount_and_get_tiers(new_cap_discount)
            if self.start_on_first_charge:
                assert start is not None
                new_cap_discount.start = start
            new_cap_discount.save()
            # Now that we saved our new cap discount, save related tiers and initialize amounts
            new_cap_discount.save_related_cap_tiers(cap_discount_tiers)
            assert new_cap_discount.start is not None
            CAPDiscountAmount.objects.create(
                cap_discount=new_cap_discount, year=start.year, month=start.month, start=0, end=0
            )
            # Also create first amount
            return new_cap_discount

    def initialize_cap_discount_and_get_tiers(self, cap_discount: CAPDiscount) -> List[CAPDiscountTier]:
        # Initialize cap discount and return cap discount tiers to be saved later
        if self.start and not self.start_on_first_charge:
            cap_discount.start = self.start
        cap_discount.reset_interval = self.reset_interval
        cap_discount.reset_frequency = self.reset_frequency
        cap_discount.charge_types = self.charge_types
        return self.copy_cap_discount_tiers(cap_discount)

    def copy_cap_discount_tiers(self, cap_discount: CAPDiscount) -> List[CAPDiscountTier]:
        # Copy the discount tiers by creating new ones for the cap discount
        tiers = []
        for cap_discount_tier in self.capdiscounttier_set.all():
            tiers.append(
                CAPDiscountTier(
                    cap_discount=cap_discount, amount=cap_discount_tier.amount, discount=cap_discount_tier.discount
                )
            )
        return tiers

    def __str__(self):
        facilities = f"{','.join(self.core_facility_names)}/" if self.core_facilities.exists() else ""
        return f"CAP Discount for {facilities}{self.rate_category.name}"


# We have no choice but to check for uniqueness here, since many to many fields cannot be used
# in validate_unique or in clean methods
@receiver(m2m_changed, sender=CAPDiscountConfiguration.core_facilities.through)
def validate_unique_cap_config(sender, instance: CAPDiscountConfiguration, action, **kwargs):
    if action in ["post_add", "post_remove", "post_clear"]:
        matching_config: QuerySetType[CAPDiscountConfiguration] = CAPDiscountConfiguration.objects.filter(
            rate_category=instance.rate_category
        ).exclude(pk=instance.pk)
        match: Optional[CAPDiscountConfiguration] = None
        if not instance.core_facilities.exists():
            match = matching_config.filter(core_facilities__isnull=True).first()
        else:
            for cap_config in matching_config:
                cap_config_facilities = set(cap_config.core_facilities.all())
                intersection = cap_config_facilities.intersection(instance.core_facilities.all())
                if intersection:
                    match = cap_config
                    break
        if match:
            raise IntegrityError(
                f"There is already a CAP Configuration for {instance.rate_category} and the selected core facility(ies): {match}"
            )


class CAPDiscount(BaseModel):
    configuration = models.ForeignKey(
        CAPDiscountConfiguration, help_text="The configuration for this CAP", on_delete=models.CASCADE
    )
    user = models.ForeignKey(
        User, blank=True, null=True, help_text="The user this CAP applies to", on_delete=models.CASCADE
    )
    account = models.ForeignKey(Account, help_text="The account this CAP applies to", on_delete=models.CASCADE)
    charge_types = models.CharField(
        validators=[validate_comma_separated_integer_list],
        max_length=CHAR_FIELD_SMALL_LENGTH,
        help_text="List of charge type this CAP applies to",
    )
    # Recurring schedule
    start_month = models.PositiveIntegerField(
        null=True, blank=True, choices=Months.choices, help_text="Start month of the CAP discount"
    )
    start_year = models.PositiveIntegerField(
        null=True,
        blank=True,
        help_text="Start year of the CAP discount",
        validators=[MinValueValidator(1900), MaxValueValidator(MAXYEAR)],
    )
    next_reset_override_month = models.PositiveIntegerField(
        null=True, blank=True, choices=Months.choices, help_text="Temporary one-time reset override month"
    )
    next_reset_override_year = models.PositiveIntegerField(
        null=True,

NEMO_billing/prepayments/views/prepayments.py
import datetime
from typing import Set

from NEMO.decorators import accounting_or_user_office_or_manager_required
from NEMO.typing import QuerySetType
from NEMO.utilities import extract_optional_beginning_and_end_dates, get_month_timeframe, month_list
from NEMO.views.pagination import SortedPaginator
from NEMO.views.usage import get_managed_projects
from dateutil.relativedelta import relativedelta
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.shortcuts import render
from django.views.decorators.http import require_http_methods

from NEMO_billing.models import CoreFacility
from NEMO_billing.prepayments.models import Fund, ProjectPrepaymentDetail
from NEMO_billing.utilities import get_charges_amount_between, number_of_months_between_dates


@login_required
def usage_project_prepayments(request):
    start_date, end_date = get_month_timeframe()
    projects = get_managed_projects(request.user)
    prepaid_projects = ProjectPrepaymentDetail.objects.filter(
        project__in=[project for project in projects if project.active]
    )
    add_fund_info_to_prepaid_projects(request, prepaid_projects, start_date)
    return render(request, "prepayments/prepaid_project_status_table.html", {"page": prepaid_projects})


@accounting_or_user_office_or_manager_required
@require_http_methods(["GET", "POST"])
def prepaid_project_status(request):
    # Default is year to date
    start_date, end_date = get_month_timeframe()
    start_date = start_date.replace(month=1)
    if request.GET.get("start"):
        submitted_start_date, submitted_end_date = extract_optional_beginning_and_end_dates(request.GET, date_only=True)
        if submitted_start_date:
            start_date = start_date.replace(year=submitted_start_date.year, month=submitted_start_date.month)
    page = SortedPaginator(ProjectPrepaymentDetail.objects.all(), request, order_by="project").get_current_page()
    add_fund_info_to_prepaid_projects(request, page.object_list, start_date)
    dictionary = {
        "start": start_date,
        "month_list": month_list(),
        "page": page,
        "core_facilities_exist": CoreFacility.objects.exists(),
    }
    return render(request, "prepayments/prepaid_project_status.html", dictionary)


def add_fund_info_to_prepaid_projects(request, prepaid_projects: QuerySetType[ProjectPrepaymentDetail], start_date):
    for prepaid_project in prepaid_projects:
        try:
            charges, charges_amount, funds = get_prepayment_info_for_status(prepaid_project, start_date)
            prepaid_project.total_funds = sum(fund.amount for fund in funds)
            prepaid_project.balance = sum(fund.balance for fund in funds)
            prepaid_project.charges_amount = sum(charge.amount for charge in charges)
            prepaid_project.taxes_amount = (
                prepaid_project.charges_amount * prepaid_project.configuration.tax_amount()
                if not prepaid_project.project.projectbillingdetails.no_tax
                else 0
            )
            prepaid_project.total_charges_amount = prepaid_project.charges_amount + prepaid_project.taxes_amount
            prepaid_project.total_funds_left = prepaid_project.balance - prepaid_project.total_charges_amount
            prepaid_project.charges = charges
            prepaid_project.charges.reverse()
        except Exception as e:
            messages.error(request, str(e), extra_tags="data-trigger=manual")


def get_prepayment_info_for_status(prepaid_project: ProjectPrepaymentDetail, fund_start_date):
    # Returns total charges, total charges amount since last updated, and all active funds since fund_start_date
    until = datetime.date.today()
    # Balance last updated is last day of previous month, so start first day of next month
    start_in_month = (prepaid_project.balance_last_updated + relativedelta(months=1)).replace(day=1)
    charges, charges_amount = get_charges_amount_between(
        prepaid_project.project, prepaid_project.configuration, start_in_month, until
    )
    # Check funds month to month
    funds: Set[Fund] = set()
    months = number_of_months_between_dates(until, fund_start_date)
    for month in range(0, months + 1):
        month_date = fund_start_date + relativedelta(months=month)
        # beginning and end of the month
        start, end = get_month_timeframe(month_date.isoformat())
        # only need to check funds valid at this date (expired or inactive won't be returned by active_funds)
        try:
            new_funds: QuerySetType[Fund] = prepaid_project.active_funds(end.date(), include_zero_balance=True)
            funds.update(new_funds)
        except Exception:
            pass
    charges.sort(key=lambda x: x.start)
    return charges, charges_amount, funds

NEMO_billing/prepayments/templates/prepayments/prepaid_project_status.html
{% extends 'billing/cap_and_prepaid_base.html' %}
{% load custom_tags_and_filters %}
{% block title %}Prepaid project status{% endblock %}
{% block tab_title %}Prepaid project status{% endblock %}
{% block before_pagination %}
    <form class="form-inline" action="{% url 'prepaid_project_status' %}" method="get">
        <input type="hidden" name="o" value="{{ request.GET.o }}">
        <label for="start" style="padding: 10px 10px 10px 0">Since</label>
        <select name="start" id="start" class="form-control" style="margin-right: 5px;text-align-last:center">
            {% for month in month_list %}
                <option value="{{ month.date|input_date_format }}"
                        {% if month|date:"F, Y" == start.date|date:"F, Y" %}selected{% endif %}>
                    {{ month|date:"F, Y" }}
                </option>
            {% endfor %}
        </select>
        {% button type="save" value="Update" %}
    </form>
{% endblock %}
{% block pagination_content %}
    {% include 'prepayments/prepaid_project_status_table.html' %}
{% endblock %}
{% block table_empty_content %}There are no prepaid projects set{% endblock %}

NEMO_billing/prepayments/templates/prepayments/prepaid_project_status_table.html
{% load custom_tags_and_filters %}
<table class="table table-bordered table-striped table-align-middle thead-light">
    <thead>
        <tr>
            {% with request_start=request.GET.start request_end=request.GET.end %}
                {% with extra_params='start='|concat:request_start|concat:'&end='|concat:request_end %}
                    <th>{% include 'pagination/pagination_column.html' with order_by="project" name='Project' %}</th>
                    <th>{% include 'pagination/pagination_column.html' with order_by="project__institution" name='Institution' %}</th>
                    <th>Allowed charges</th>
                    {% if core_facilities_exist %}
                        <th>
                            {% include 'pagination/pagination_column.html' with order_by="only_core_facilities" name='Allowed facilities' %}
                        </th>
                    {% endif %}
                    <th class="text-right">Total active funds</th>
                    <th>{% include 'pagination/pagination_column.html' with order_by="balance_last_updated" name='Updated' %}</th>
                    <th>Balance</th>
                    <th class="text-right">Charges since</th>
                    <th class="text-right">Current balance</th>
                    <th class="text-right button-column-minimum">Charges</th>
                {% endwith %}
            {% endwith %}
        </tr>
    </thead>
    <tbody>
        {% for prepaid_project in page %}
            <tr>
                {% if prepaid_project.charges %}
                    <td id="chevron_{{ prepaid_project.id }}"
                        data-toggle="collapse"
                        data-target=".prepaid_project_{{ prepaid_project.id }}"
                        onclick="toggle_details($('#chevron_{{ prepaid_project.id }}'))">
                        <span class="glyphicon glyphicon-chevron-right pull-left chevron"></span>
                        {{ prepaid_project.project }}
                    </td>
                {% else %}
                    <td>{{ prepaid_project.project }}</td>
                {% endif %}
                <td>{{ prepaid_project.project.institution }}</td>
                <td>{{ prepaid_project.get_charge_types_display }}</td>
                {% if core_facilities_exist %}<td>{{ prepaid_project.get_only_core_facilities_display }}</td>{% endif %}
                <td class="text-right">{{ prepaid_project.total_funds|floatformat:2 }}</td>
                <td class="text-center">{{ prepaid_project.balance_last_updated|date:"SHORT_DATE_FORMAT" }}</td>
                <td class="text-right">{{ prepaid_project.balance|floatformat:2 }}</td>
                <td class="text-right">{{ prepaid_project.total_charges_amount|floatformat:2 }}</td>
                <td class="text-right">{{ prepaid_project.total_funds_left|floatformat:2 }}</td>
                <td class="text-right">
                    {% if prepaid_project.charges %}
                        <button class="btn btn-sm btn-primary"
                                type="button"
                                onclick="toggle_details($('#chevron_{{ prepaid_project.id }}'))"
                                title="See charges"
                                aria-label="See charges"
                                data-toggle="collapse"
                                data-target=".prepaid_project_{{ prepaid_project.id }}">
                            <i class="glyphicon glyphicon-list"></i> See charges
                        </button>
                    {% endif %}
                </td>
            </tr>
            {% if prepaid_project.charges %}
                <tr class="collapse prepaid_project_{{ prepaid_project.id }}">
                    <td colspan="{% if core_facilities_exist %}9{% else %}8{% endif %}" style="padding: 0">
                        <table class="table table-bordered table-align-middle table-condensed" style="margin: 0">
                            <thead>
                                <tr>
                                    <th class="alert-info">User</th>
                                    <th class="alert-info">Item</th>
                                    <th class="alert-info">Date</th>
                                    <th class="alert-info">Duration</th>
                                    <th class="alert-info text-right">Amount</th>
                                </tr>
                            </thead>
                            {% for charge in prepaid_project.charges %}
                                <tr>
                                    <td>{{ charge.user }}</td>
                                    <td>{{ charge.name }}</td>
                                    <td>{{ charge.start|date:"SHORT_DATETIME_FORMAT" }}</td>
                                    <td>{{ charge.display_quantity }}</td>
                                    <td class="text-right">{{ charge.amount|floatformat:2 }}</td>
                                </tr>
                            {% endfor %}
                            <tr>
                                <td colspan="4" class="text-right">
                                    {% if prepaid_project.taxes_amount %}
                                        Subtotal
                                    {% else %}
                                        Total
                                    {% endif %}
                                </td>
                                <td class="text-right">{{ prepaid_project.charges_amount|floatformat:2 }}</td>
                            </tr>
                            {% if prepaid_project.taxes_amount %}
                                <tr>
                                    <td colspan="4" class="text-right">Taxes</td>
                                    <td class="text-right">{{ prepaid_project.taxes_amount|floatformat:2 }}</td>
                                </tr>
                                <tr>
                                    <td colspan="4" class="text-right">Total</td>
                                    <td class="text-right">{{ prepaid_project.total_charges_amount|floatformat:2 }}</td>
                                </tr>
                            {% endif %}
                        </table>
                    </td>
                </tr>
            {% endif %}
        {% endfor %}
    </tbody>
</table>